
import java.util.*;
import java.io.*;

public class DatabaseIO {
	private ArrayList<Media> media;
	private String musicFile = "Music.txt";
	private String videoFile = "Video.txt";

	public DatabaseIO(ArrayList<Media> media) {
		this.media = media;
	}

	public void readInFiles() {
		readInMusic();
		readInVideo();
	}

	private void readInMusic() {
		File filename = new File(musicFile);
		try {
			FileReader fin = new FileReader(filename);
			Scanner in = new Scanner(fin);
			while (in.hasNextLine()) {
				String s = in.nextLine();
				Music n = new Music();
				if (!n.inputFromString(s)) {
					continue;
				}
				media.add(n);
			}
			fin.close();
		}
		catch (FileNotFoundException e) {
			System.err.println("File " + filename.getName() + " not found");
		}
		catch (IOException e) {
			System.err.println("Error reading from " + filename.getName());
		}
	}
	

	public void writeToMusic(ArrayList<Music> music) {
		File filename = new File(musicFile);
		try {
			if (filename.exists()) {
				filename.delete();
			}
			filename.createNewFile();
			PrintWriter out = new PrintWriter(filename);
			for (Music m : music) {
				out.println(m.output());
			}
			out.close();
		}
		catch (FileNotFoundException e) {
			System.err.println("File " + filename.getName() + " not found");
		}
		catch (IOException e) {
			System.err.println("Error writing to " + filename.getName());
		}
	}


	private void readInVideo() {
		File filename = new File(videoFile);
		try {
			FileReader fin = new FileReader(filename);
			Scanner in = new Scanner(fin);
			while (in.hasNextLine()) {
				String s = in.nextLine();
				Video n = new Video();
				if (!n.inputFromString(s)) {
					continue;
				}
				media.add(n);
			}
			fin.close();
		}
		catch (FileNotFoundException e) {
			System.err.println("File " + filename.getName() + " not found");
		}
		catch (IOException e) {
			System.err.println("Error reading from " + filename.getName());
		}
	}


	public void writeToVideo(ArrayList<Video> videos) {
		File filename = new File(videoFile);
		try {
			if (filename.exists()) {
				filename.delete();
			}
			filename.createNewFile();
			PrintWriter out = new PrintWriter(filename);
			for (Video v : videos) {
				out.println(v.output());
			}
			out.close();
		}
		catch (FileNotFoundException e) {
			System.err.println("File " + filename.getName() + " not found");
		}
		catch (IOException e) {
			System.err.println("Error writing to " + filename.getName());
		}
	}
}