
import java.util.*;

public class Music extends Media {
	private String artist;
	private String album;
	private String genre;
	private int tracks;
	private int year;
	private int time;
	
	public Music() {
		super();
	}

	public Music(String artist, String album, String genre, int tracks, int year, int time, String mediaType) {
		super(mediaType);
		this.artist = artist;
		this.album = album;
		this.genre = genre;
		this.tracks = tracks;
		this.year = year;
		this.time = time;
	}
	
	public void changeArtist(String artist) {
		this.artist = artist;
	}

	public void changeAlbum(String album) {
		this.album = album;
	}
	
	public void changeGenre(String genre) {
		this.genre = genre;
	}
	
	public void changeTracks(int tracks) {
		this.tracks = tracks;
	}
	
	public void changeYear(int year) {
		this.year = year;
	}
	
	public void changeTime(int time) {
		this.time = time;
	}
	
	public void changeMediaType(String mediaType) {
		this.mediaType = mediaType;
	}

	public boolean inputFromString(String inputString) {
		try {
			Scanner input = new Scanner(inputString);
			input.useDelimiter("; *");

			artist = input.next();
			album = input.next();
			genre = input.next();
			tracks = input.nextInt();
			year = input.nextInt();
			time = input.nextInt();
			mediaType = input.next();

			return true;
		}
		catch (NoSuchElementException e) {
			System.err.println("Input file in wrong format");
			return false;
		}
 		catch (Exception e) {
			System.err.println("Input file error");
			return false;
		}
	}

	public boolean search(String input) {
		String[] keywords = input.split(" ");
		String[] a = artist.split(" ");
		String[] b = album.split(" ");
		String[] c = genre.split(" ");

		String[] data = joinArrays(a, b);
		data = joinArrays(data, c);

		searchHit = searchEngine(keywords, data);

		if (searchHit >= 10) {
			return true;
		}
		return false;
	}

	//add all the shit here????
	public  String toString() {
		return "\n\nID:\t   " + iD +
			   "\nArtist:\t   " + artist +
			   "\nAlbum:\t   " + album +
			   "\nYear:\t   " + year +
			   "\nGenre:\t   " + genre +
			   "\nTracks:\t   " + tracks +
			   "\nTime:\t   " + time +
			   "\nMedia:\t   " + mediaType + "\n\n";
	}

	public  String toStringSimple() {
		return iD + "\t" + Input.sizeString(artist) + Input.sizeString(album) + year;
	}

	public  String toStringSearch() {
		return iD + "\t" + Input.sizeString(artist) + Input.sizeString(album) + year + "\t" + searchHit;
	}
	
	public String output() {
		return artist + "; " + album + "; " + genre + "; " + tracks + "; " + year + "; " + time + "; " + mediaType;
	}

}
